Report: Add rls data
[csit.git] / resources / libraries / bash / function / device.sh
1 # Copyright (c) 2021 Cisco and/or its affiliates.
2 # Licensed under the Apache License, Version 2.0 (the "License");
3 # you may not use this file except in compliance with the License.
4 # You may obtain a copy of the License at:
5 #
6 #     http://www.apache.org/licenses/LICENSE-2.0
7 #
8 # Unless required by applicable law or agreed to in writing, software
9 # distributed under the License is distributed on an "AS IS" BASIS,
10 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
11 # See the License for the specific language governing permissions and
12 # limitations under the License.
13
14 set -exuo pipefail
15
16 # This library defines functions used by multiple entry scripts.
17 # Deliberately not depending on common.sh to allow standalone usage.
18 # Keep functions ordered alphabetically, please.
19
20 function activate_wrapper () {
21
22     # Acts as wrapper for activate docker topology.
23     #
24     # Variables read:
25     # - ${1} - Node multiplicity of desired testbed.
26     # - ${2} - Node flavor string, usually describing the processor.
27     # - ${3} - CSIT-SUT-DCR image name and version.
28
29     set -exuo pipefail
30
31     enter_mutex || die
32     get_available_interfaces "${1}" "${2}" || die
33     start_topology_containers "${3}" || die
34     bind_interfaces_to_containers || die
35     set_env_variables || die
36     print_env_variables || die
37     exit_mutex || die
38 }
39
40
41 function bind_interfaces_to_containers () {
42
43     # Bind linux network interface to container and create symlink for PCI
44     # address in container.
45     #
46     # Variables read:
47     # - DCR_UUIDS - Docker Container UUIDs.
48     # - DCR_CPIDS - Docker Container PIDs (namespaces).
49     # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
50     # - PCI_ADDR - PCI address of network device.
51     # - TG_NETDEVS - List of network devices allocated to TG container.
52     # Variables set:
53     # - NETDEV - Linux network interface.
54
55     set -exuo pipefail
56
57     for NETDEV in "${TG_NETDEVS[@]}"; do
58         get_pci_addr || die
59         link_target=$(readlink -f /sys/bus/pci/devices/"${PCI_ADDR}") || {
60             die "Reading symlink for PCI address failed!"
61         }
62         cmd="ln -s ${link_target} /sys/bus/pci/devices/${PCI_ADDR}"
63
64         sudo ip link set ${NETDEV} netns ${DCR_CPIDS[tg]} || {
65             die "Moving interface to ${DCR_CPIDS[tg]} namespace failed!"
66         }
67         docker exec "${DCR_UUIDS[tg]}" ${cmd} || {
68             die "Linking PCI address in container failed!"
69         }
70     done
71     for NETDEV in "${DUT1_NETDEVS[@]}"; do
72         get_pci_addr || die
73         link_target=$(readlink -f /sys/bus/pci/devices/"${PCI_ADDR}") || {
74             die "Reading symlink for PCI address failed!"
75         }
76         cmd="ln -s ${link_target} /sys/bus/pci/devices/${PCI_ADDR}"
77
78         sudo ip link set ${NETDEV} netns ${DCR_CPIDS[dut1]} || {
79             die "Moving interface to ${DCR_CPIDS[dut1]} namespace failed!"
80         }
81         docker exec "${DCR_UUIDS[dut1]}" ${cmd} ||  {
82             die "Linking PCI address in container failed!"
83         }
84     done
85 }
86
87
88 function bind_interfaces_to_driver () {
89
90     # Bind network interface specified by parameter to driver specified by
91     # parameter.
92     #
93     # Variables read:
94     # - ADDR - PCI address of network interface.
95     # - DRIVER - Kernel driver.
96
97     set -exuo pipefail
98
99     pci_path="/sys/bus/pci/devices/${ADDR}"
100     drv_path="/sys/bus/pci/drivers/${DRIVER}"
101     if [ -d "${pci_path}/driver" ]; then
102         echo ${ADDR} | sudo tee ${pci_path}/driver/unbind || {
103             die "Failed to unbind interface ${ADDR}!"
104         }
105     fi
106     echo ${ADDR} | sudo tee ${drv_path}/bind || {
107         die "Failed to bind interface ${ADDR}!"
108     }
109 }
110
111
112 function clean_environment () {
113
114     # Cleanup environment by removing topology containers and shared volumes
115     # and binding interfaces back to original driver.
116     #
117     # Variables read:
118     # - DCR_UUIDS - Docker Container UUIDs.
119     # - DUT1_PCIDEVS - List of PCI addresses of devices of DUT1 container.
120     # - TG_PCIDEVS - List of PCI addresses of devices of TG container.
121     # Variables set:
122     # - ADDR - PCI address of network interface.
123     # - DRIVER - Kernel driver.
124
125     set -exuo pipefail
126
127     # Kill docker containers.
128     docker rm --force "${DCR_UUIDS[@]}" || die "Cleanup containers failed!"
129
130     # Check if there are some leftover containers and remove all. Command will
131     # not fail in case there are no containers to remove.
132     docker rm --force $(docker ps -q --filter name=${DCR_UUIDS[dut1]}) || {
133         warn "Failed to remove hanged containers or nothing to remove!"
134     }
135
136     # Rebind interfaces back to kernel drivers.
137     for ADDR in ${TG_PCIDEVS[@]}; do
138         DRIVER="${TG_DRIVERS[0]}"
139         bind_interfaces_to_driver || die
140     done
141     for ADDR in ${DUT1_PCIDEVS[@]}; do
142         DRIVER="${DUT1_DRIVERS[0]}"
143         bind_interfaces_to_driver || die
144     done
145 }
146
147
148 function clean_environment_on_exit () {
149
150     # Cleanup environment by removing topology containers and binding
151     # interfaces back to original driver only if exit code is not 0.
152     # This function acts as workaround as 'set -eu' does not trigger ERR trap.
153
154     set -exuo pipefail
155
156     if [ $? -ne 0 ]; then
157         clean_environment || die
158     fi
159 }
160
161
162 function deactivate_wrapper () {
163
164     # Acts as wrapper for deactivate docker topology.
165     #
166     # Variables read:
167     # - ${@} - CSIT environment variables.
168
169     set -exuo pipefail
170
171     enter_mutex || die
172     read_env_variables "${@}" || die
173     clean_environment || die
174     exit_mutex || die
175 }
176
177
178 function die () {
179
180     # Print the message to standard error end exit with error code specified
181     # by the second argument.
182     #
183     # Duplicate of common.sh function, as this file is also used standalone.
184     #
185     # Hardcoded values:
186     # - The default error message.
187     # Arguments:
188     # - ${1} - The whole error message, be sure to quote. Optional
189     # - ${2} - the code to exit with, default: 1.
190
191     set -x
192     set +eu
193     warn "${1:-Unspecified run-time error occurred!}"
194     exit "${2:-1}"
195 }
196
197
198 function enter_mutex () {
199
200     # Enter mutual exclusion for protecting execution from starvation and
201     # deadlock.
202
203     set -exuo pipefail
204
205     mutex_timeout=3600
206     mutex_file="/tmp/mutex_file"
207
208     # Create mutex.
209     exec {lock_fd}>${mutex_file} || {
210         die "Mutex enter failed!"
211     }
212     flock --timeout "${mutex_timeout}" "${lock_fd}" || {
213         die "Calling flock() failed!"
214     }
215     # ----------------------
216     # Enter mutex succeeded.
217     warn "Mutex enter succeeded for PID $$."
218 }
219
220
221 function exit_mutex () {
222
223     # Exit mutual exclusion.
224
225     set -exuo pipefail
226
227     # ---------------------
228     # Remove mutex so we are not blocking others anymore.
229     flock -u "${lock_fd}" || {
230         die "Mutex destroy failed!"
231     }
232     warn "Mutex leave succeeded for PID $$."
233 }
234
235
236 function get_available_interfaces () {
237
238     # Find and get available Virtual functions.
239     #
240     # Arguments:
241     # - ${1} - Nodeness, as set by common.sh get_test_code.
242     # - ${2} - Flavor, as set by common.sh get_test_code.
243     # Variables set:
244     # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
245     # - DUT1_PCIDEVS - List of PCI addresses allocated to DUT1 container.
246     # - DUT1_NETMACS - List of MAC addresses allocated to DUT1 container.
247     # - DUT1_DRIVERS - List of interface drivers to DUT1 container.
248     # - TG_NETDEVS - List of network devices allocated to TG container.
249     # - TG_PCIDEVS - List of PCI addresses allocated to TG container.
250     # - TG_NETMACS - List of MAC addresses allocated to TG container.
251     # - TG_DRIVERS - List of interface drivers to TG container.
252
253     set -exuo pipefail
254
255     # Following code is specifing VFs ID based on nodeness and flavor.
256     # As there is great variability in hardware configuration outside LF,
257     # from bootstrap architecure point of view these are considered as flavors.
258     # Anyone can override flavor for its own machine and add condition here.
259     # See http://pci-ids.ucw.cz/v2.2/pci.ids for more info.
260     case_text="${1}_${2}"
261     case "${case_text}" in
262         "1n_skx")
263             # Add Intel Corporation XL710/X710 Virtual Function to the
264             # whitelist.
265             pci_id="0x154c"
266             tg_netdev=(ens1 enp24)
267             dut1_netdev=(ens5 enp59)
268             ;;
269        "1n_tx2")
270             # Add Intel Corporation XL710/X710 Virtual Function to the
271             # whitelist.
272             pci_id="0x154c"
273             tg_netdev=(enp5)
274             dut1_netdev=(enp145)
275             ;;
276        "1n_vbox")
277             # Add Intel Corporation 82545EM Gigabit Ethernet Controller to the
278             # whitelist.
279             pci_id="0x100f"
280             tg_netdev=(enp0s8 enp0s9)
281             dut1_netdev=(enp0s16 enp0s17)
282             ;;
283         *)
284             die "Unknown specification: ${case_text}!"
285     esac
286
287     device_count=2
288
289     # TG side of connections.
290     TG_NETDEVS=()
291     TG_PCIDEVS=()
292     TG_NETMACS=()
293     TG_DRIVERS=()
294     TG_VLANS=()
295     # DUT1 side of connections.
296     DUT1_NETDEVS=()
297     DUT1_PCIDEVS=()
298     DUT1_NETMACS=()
299     DUT1_DRIVERS=()
300     DUT1_VLANS=()
301
302     # Find the first ${device_count} number of available TG Linux network
303     # VF device names. Only allowed VF PCI IDs are filtered.
304     for netdev in ${tg_netdev[@]}
305     do
306         for netdev_path in $(grep -l "${pci_id}" \
307                              /sys/class/net/${netdev}*/device/device \
308                              2> /dev/null)
309         do
310             if [[ ${#TG_NETDEVS[@]} -lt ${device_count} ]]; then
311                 tg_netdev_name=$(dirname ${netdev_path})
312                 tg_netdev_name=$(dirname ${tg_netdev_name})
313                 TG_NETDEVS+=($(basename ${tg_netdev_name}))
314             else
315                 break
316             fi
317         done
318         if [[ ${#TG_NETDEVS[@]} -eq ${device_count} ]]; then
319             break
320         fi
321     done
322
323     i=0
324     for netdev in "${TG_NETDEVS[@]}"; do
325         # Find the index of selected tg netdev among tg_netdevs
326         # e.g. enp8s5f7 is a vf of netdev enp8s5 with index 11
327         # and the corresponding dut1 netdev is enp133s13.
328         while [[ "${netdev}" != "${tg_netdev[$i]}"* ]]; do
329             ((i++))
330         done
331         # Rename tg netdev to dut1 netdev
332         # e.g. enp8s5f7 -> enp133s13f7
333         DUT1_NETDEVS+=(${netdev/${tg_netdev[$i]}/${dut1_netdev[$i]}})
334         # Don't need to reset i, all netdevs are sorted.
335     done
336
337     for NETDEV in "${TG_NETDEVS[@]}"; do
338         get_pci_addr
339         get_mac_addr
340         get_krn_driver
341         get_vlan_filter
342         TG_PCIDEVS+=(${PCI_ADDR})
343         TG_NETMACS+=(${MAC_ADDR})
344         TG_DRIVERS+=(${KRN_DRIVER})
345         TG_VLANS+=(${VLAN_ID})
346     done
347     for NETDEV in "${DUT1_NETDEVS[@]}"; do
348         get_pci_addr
349         get_mac_addr
350         get_krn_driver
351         get_vlan_filter
352         DUT1_PCIDEVS+=(${PCI_ADDR})
353         DUT1_NETMACS+=(${MAC_ADDR})
354         DUT1_DRIVERS+=(${KRN_DRIVER})
355         DUT1_VLANS+=(${VLAN_ID})
356     done
357
358     # We need at least two interfaces for TG/DUT1 for building topology.
359     if [ "${#TG_NETDEVS[@]}" -ne 2 ] || [ "${#DUT1_NETDEVS[@]}" -ne 2 ]; then
360         die "Not enough linux network interfaces found!"
361     fi
362     if [ "${#TG_PCIDEVS[@]}" -ne 2 ] || [ "${#DUT1_PCIDEVS[@]}" -ne 2 ]; then
363         die "Not enough pci interfaces found!"
364     fi
365 }
366
367
368 function get_krn_driver () {
369
370     # Get kernel driver from linux network device name.
371     #
372     # Variables read:
373     # - PCI_ADDR - PCI address of network device.
374     # Variables set:
375     # - KRN_DRIVER - Kernel driver of network device.
376
377     set -exuo pipefail
378
379     pci_path="/sys/bus/pci/devices/${PCI_ADDR}"
380     KRN_DRIVER="$(basename $(readlink -f ${pci_path}/driver))" || {
381         die "Failed to get kernel driver of PCI interface!"
382     }
383 }
384
385
386 function get_mac_addr () {
387
388     # Get MAC address from linux network device name.
389     #
390     # Variables read:
391     # - NETDEV - Linux network device name.
392     # Variables set:
393     # - MAC_ADDR - MAC address of network device.
394
395     set -exuo pipefail
396
397     if [ -d /sys/class/net/${NETDEV}/device ]; then
398         MAC_ADDR="$(</sys/class/net/${NETDEV}/address)" || {
399             die "Failed to get MAC address of linux network interface!"
400         }
401     fi
402 }
403
404
405 function get_pci_addr () {
406
407     # Get PCI address in <domain>:<bus:<device>.<func> format from linux network
408     # device name.
409     #
410     # Variables read:
411     # - NETDEV - Linux network device name.
412     # Variables set:
413     # - PCI_ADDR - PCI address of network device.
414
415     set -exuo pipefail
416
417     if [ -d /sys/class/net/${NETDEV}/device ]; then
418         PCI_ADDR=$(basename $(readlink /sys/class/net/${NETDEV}/device)) || {
419             die "Failed to get PCI address of linux network interface!"
420         }
421     fi
422     if [ ! -d /sys/bus/pci/devices/${PCI_ADDR} ]; then
423         die "PCI device ${NETDEV} doesn't exist!"
424     fi
425 }
426
427
428 function get_vlan_filter () {
429
430     # Get VLAN stripping filter from PF searched by mac adress.
431     #
432     # Variables read:
433     # - MAC_ADDR - MAC address of VF.
434     # Variables set:
435     # - VLAN_ID - VLAN ids.
436
437     set -exuo pipefail
438
439     # Sed regular expression pattern.
440     exp="s/^.*vlan ([[:digit:]]+).*$/\1/"
441     VLAN_ID=$(ip link | grep vlan | grep ${MAC_ADDR} | sed -re "${exp}") || true
442     VLAN_ID="${VLAN_ID:-0}"
443 }
444
445
446 function installed () {
447
448     # Check if the given utility is installed. Fail if not installed.
449     #
450     # Duplicate of common.sh function, as this file is also used standalone.
451     #
452     # Arguments:
453     # - ${1} - Utility to check.
454     # Returns:
455     # - 0 - If command is installed.
456     # - 1 - If command is not installed.
457
458     set -exuo pipefail
459
460     command -v "${1}"
461 }
462
463
464 function print_env_variables () {
465
466     # Get environment variables prefixed by CSIT_.
467
468     set -exuo pipefail
469
470     env | grep CSIT_ || true
471 }
472
473
474 function read_env_variables () {
475
476     # Read environment variables from parameters.
477     #
478     # Arguments:
479     # - ${@} - Variables passed as an argument.
480     # Variables read, set or exported: Multiple,
481     # see the code for the current list.
482     # TODO: Do we need to list them and their meanings?
483
484     set -exuo pipefail
485
486     for param in "$@"; do
487         export "${param}"
488     done
489     declare -gA DCR_UUIDS
490     DCR_UUIDS+=([tg]="${CSIT_TG_UUID}")
491     DCR_UUIDS+=([dut1]="${CSIT_DUT1_UUID}")
492     TG_PCIDEVS=("${CSIT_TG_INTERFACES_PORT1_PCI}")
493     TG_DRIVERS=("${CSIT_TG_INTERFACES_PORT1_DRV}")
494     TG_VLANS+=("${CSIT_TG_INTERFACES_PORT1_VLAN}")
495     TG_PCIDEVS+=("${CSIT_TG_INTERFACES_PORT2_PCI}")
496     TG_DRIVERS+=("${CSIT_TG_INTERFACES_PORT2_DRV}")
497     TG_VLANS+=("${CSIT_TG_INTERFACES_PORT2_VLAN}")
498     DUT1_PCIDEVS=("${CSIT_DUT1_INTERFACES_PORT1_PCI}")
499     DUT1_DRIVERS=("${CSIT_DUT1_INTERFACES_PORT1_DRV}")
500     DUT1_VLANS+=("${CSIT_DUT1_INTERFACES_PORT1_VLAN}")
501     DUT1_PCIDEVS+=("${CSIT_DUT1_INTERFACES_PORT2_PCI}")
502     DUT1_DRIVERS+=("${CSIT_DUT1_INTERFACES_PORT2_DRV}")
503     DUT1_VLANS+=("${CSIT_DUT1_INTERFACES_PORT2_VLAN}")
504 }
505
506
507 function set_env_variables () {
508
509     # Set environment variables.
510     #
511     # Variables read:
512     # - DCR_UUIDS - Docker Container UUIDs.
513     # - DCR_PORTS - Docker Container's SSH ports.
514     # - DUT1_NETMACS - List of network devices MAC addresses of DUT1 container.
515     # - DUT1_PCIDEVS - List of PCI addresses of devices of DUT1 container.
516     # - DUT1_DRIVERS - List of interface drivers to DUT1 container.
517     # - TG_NETMACS - List of network devices MAC addresses of TG container.
518     # - TG_PCIDEVS - List of PCI addresses of devices of TG container.
519     # - TG_DRIVERS - List of interface drivers to TG container.
520     # Variables set: TODO.
521
522     set -exuo pipefail
523
524     set -a
525     CSIT_TG_HOST="$(hostname --all-ip-addresses | awk '{print $1}')" || {
526         die "Reading hostname IP address failed!"
527     }
528     CSIT_TG_PORT="${DCR_PORTS[tg]#*:}"
529     CSIT_TG_UUID="${DCR_UUIDS[tg]}"
530     CSIT_TG_ARCH="$(uname -i)" || {
531         die "Reading machine architecture failed!"
532     }
533     CSIT_DUT1_HOST="$(hostname --all-ip-addresses | awk '{print $1}')" || {
534         die "Reading hostname IP address failed!"
535     }
536     CSIT_DUT1_PORT="${DCR_PORTS[dut1]#*:}"
537     CSIT_DUT1_UUID="${DCR_UUIDS[dut1]}"
538     CSIT_DUT1_ARCH="$(uname -i)" || {
539         die "Reading machine architecture failed!"
540     }
541     CSIT_TG_INTERFACES_PORT1_MAC="${TG_NETMACS[0]}"
542     CSIT_TG_INTERFACES_PORT1_PCI="${TG_PCIDEVS[0]}"
543     CSIT_TG_INTERFACES_PORT1_DRV="${TG_DRIVERS[0]}"
544     CSIT_TG_INTERFACES_PORT1_VLAN="${TG_VLANS[0]}"
545     CSIT_TG_INTERFACES_PORT2_MAC="${TG_NETMACS[1]}"
546     CSIT_TG_INTERFACES_PORT2_PCI="${TG_PCIDEVS[1]}"
547     CSIT_TG_INTERFACES_PORT2_DRV="${TG_DRIVERS[1]}"
548     CSIT_TG_INTERFACES_PORT2_VLAN="${TG_VLANS[1]}"
549     CSIT_DUT1_INTERFACES_PORT1_MAC="${DUT1_NETMACS[0]}"
550     CSIT_DUT1_INTERFACES_PORT1_PCI="${DUT1_PCIDEVS[0]}"
551     CSIT_DUT1_INTERFACES_PORT1_DRV="${DUT1_DRIVERS[0]}"
552     CSIT_DUT1_INTERFACES_PORT1_VLAN="${DUT1_VLANS[0]}"
553     CSIT_DUT1_INTERFACES_PORT2_MAC="${DUT1_NETMACS[1]}"
554     CSIT_DUT1_INTERFACES_PORT2_PCI="${DUT1_PCIDEVS[1]}"
555     CSIT_DUT1_INTERFACES_PORT2_DRV="${DUT1_DRIVERS[1]}"
556     CSIT_DUT1_INTERFACES_PORT2_VLAN="${DUT1_VLANS[1]}"
557     set +a
558 }
559
560
561 function start_topology_containers () {
562
563     # Starts csit-sut-dcr docker containers for TG/DUT1.
564     #
565     # Variables read:
566     # - CSIT_DIR - Path to existing root of local CSIT git repository.
567     # Variables set:
568     # - DCR_UUIDS - Docker Container UUIDs.
569     # - DCR_PORTS - Docker Container SSH TCP ports.
570     # - DCR_CPIDS - Docker Container PIDs (namespaces).
571
572     set -exuo pipefail
573
574     if ! installed docker; then
575         die "Docker not present. Please install before continue!"
576     fi
577
578     # If the IMAGE is not already loaded then docker run will pull the IMAGE,
579     # and all image dependencies, before it starts the container.
580     dcr_image="${1}"
581     # Run the container in the background and print the new container ID.
582     dcr_stc_params="--detach=true "
583     # Give extended privileges to this container. A "privileged" container is
584     # given access to all devices and able to run nested containers.
585     dcr_stc_params+="--privileged "
586     # Publish all exposed ports to random ports on the host interfaces.
587     dcr_stc_params+="--publish-all "
588     # Automatically remove the container when it exits.
589     dcr_stc_params+="--rm "
590     # Size of /dev/shm.
591     dcr_stc_params+="--shm-size 2G "
592     # Override access to PCI bus by attaching a filesystem mount to the
593     # container.
594     dcr_stc_params+="--mount type=tmpfs,destination=/sys/bus/pci/devices "
595     # Mount vfio to be able to bind to see bound interfaces. We cannot use
596     # --device=/dev/vfio as this does not see newly bound interfaces.
597     dcr_stc_params+="--volume /dev/vfio:/dev/vfio "
598     # Disable manipulation with hugepages by VPP.
599     dcr_stc_params+="--volume /dev/null:/etc/sysctl.d/80-vpp.conf "
600     # Mount docker.sock to be able to use docker deamon of the host.
601     dcr_stc_params+="--volume /var/run/docker.sock:/var/run/docker.sock "
602     # Mount /opt/boot/ where VM kernel and initrd are located.
603     dcr_stc_params+="--volume /opt/boot/:/opt/boot/ "
604     # Mount host hugepages for VMs.
605     dcr_stc_params+="--volume /dev/hugepages/:/dev/hugepages/ "
606     # Disable IPv6.
607     dcr_stc_params+="--sysctl net.ipv6.conf.all.disable_ipv6=1 "
608     dcr_stc_params+="--sysctl net.ipv6.conf.default.disable_ipv6=1 "
609
610     # Docker Container UUIDs.
611     declare -gA DCR_UUIDS
612     # Docker Container SSH TCP ports.
613     declare -gA DCR_PORTS
614     # Docker Container PIDs (namespaces).
615     declare -gA DCR_CPIDS
616
617     # Run TG and DUT1. As initial version we do support only 2-node.
618     params=(${dcr_stc_params} --name csit-tg-$(uuidgen) ${dcr_image})
619     DCR_UUIDS+=([tg]=$(docker run "${params[@]}")) || {
620         die "Failed to start TG docker container!"
621     }
622     params=(${dcr_stc_params} --name csit-dut1-$(uuidgen) ${dcr_image})
623     DCR_UUIDS+=([dut1]=$(docker run "${params[@]}")) || {
624         die "Failed to start DUT1 docker container!"
625     }
626
627     trap 'clean_environment_on_exit' EXIT || {
628         die "Trap attempt failed, please cleanup manually. Aborting!"
629     }
630
631     # Get Containers TCP ports.
632     params=(${DCR_UUIDS[tg]})
633     DCR_PORTS+=([tg]=$(docker port "${params[@]}")) || {
634         die "Failed to get port of TG docker container!"
635     }
636     params=(${DCR_UUIDS[dut1]})
637     DCR_PORTS+=([dut1]=$(docker port "${params[@]}")) || {
638         die "Failed to get port of DUT1 docker container!"
639     }
640
641     # Get Containers PIDs.
642     params=(--format="{{ .State.Pid }}" ${DCR_UUIDS[tg]})
643     DCR_CPIDS+=([tg]=$(docker inspect "${params[@]}")) || {
644         die "Failed to get PID of TG docker container!"
645     }
646     params=(--format="{{ .State.Pid }}" ${DCR_UUIDS[dut1]})
647     DCR_CPIDS+=([dut1]=$(docker inspect "${params[@]}")) || {
648         die "Failed to get PID of DUT1 docker container!"
649     }
650 }
651
652 function warn () {
653     # Print the message to standard error.
654     #
655     # Duplicate of common.sh function, as this file is also used standalone.
656     #
657     # Arguments:
658     # - ${@} - The text of the message.
659
660     set -exuo pipefail
661
662     echo "$@" >&2
663 }